/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Leveleditor  which runs under GPL.
*****************************************************************************************/

// Hauptfenster Leveleditor - Version 06.01.2005 

#include "l_window.h"
#include <stdio.h>
#include <qapplication.h>

// ================================================================================================

window::window(QWidget *parent,char* name): QHBox(parent,name)
{ int i;
  QString temp;

  //Geometrie und Aussehen: Elemente bei einer QHBox sind spaltenfoermig angelegt:
  this->setMargin(8);
  this->setSpacing(4);
  this->setBackgroundColor(BACKGR0);
  this->setBackgroundPixmap(QPixmap(BACKPIX0));
  this->setCaption(_TITEL);  

  QHBox* centerwig=new QHBox(this);
  centerwig->setPaletteBackgroundColor(BACKGR0);
  centerwig->setPaletteBackgroundPixmap(QPixmap(BACKPIX0));
  centerwig->setBackgroundOrigin(WindowOrigin);
  centerwig->setMaximumSize(800,600);
  

// erste Spalte: Zeile oben: Canvasview (Brett)
  QVBox* p_spalte0=new QVBox(centerwig);
  p_spalte0->setPaletteForegroundColor(COLOR0);
  p_spalte0->setPaletteBackgroundColor(BACKGR0);
  p_spalte0->setSpacing(8);
  p_spalte0->setPaletteBackgroundPixmap(QPixmap(BACKPIX0));
  p_spalte0->setBackgroundOrigin(WindowOrigin);
  my_view=new viewport(p_spalte0,"playfield"); // QCanvasView-Variante

// zweite Spalte:  
  QVBox* p_spalte1=new QVBox(centerwig);
  p_spalte1->setPaletteBackgroundColor(BACKGR0);
  p_spalte1->setPaletteForegroundColor(COLOR0);
  p_spalte1->setSpacing(4);
  p_spalte1->setMargin(8);
  p_spalte1->setMaximumWidth(DX*XMAX/2+OFX);
  p_spalte1->setPaletteBackgroundPixmap(QPixmap(BACKPIX0));
  p_spalte1->setBackgroundOrigin(WindowOrigin);
  
  QLabel* p_ue =new QLabel(p_spalte1);
  temp="<h3>Level Editor FleurII</h3>";
  p_ue->setText(temp);
  p_ue->setMinimumSize(160,32);
  p_ue->setPaletteBackgroundPixmap(QPixmap(BACKPIX0));
  p_ue->setBackgroundOrigin(WindowOrigin);

  p_messi=new QLabel(_NO_LEVEL,p_spalte1);
  p_messi->setPaletteForegroundColor(COLOR0);
  p_messi->setMinimumSize(60,32);
   
  QValidator* intvalidator=new QIntValidator(-1,999,this); // Zahlen 1-999
  QValidator* strvalidator=new QRegExpValidator(QRegExp("[\\s\\w\\-\\.!?,:=+*'/]{1,31}"),0); 

// Eingabefelder Levelname, max.Zeit:
  QLabel* p_llname=new QLabel(p_spalte1); p_llname->setText(_LNAME); 
  p_text=new QLineEdit(p_spalte1); p_text->setValidator(strvalidator);
  QLabel* p_lzeit=new QLabel(p_spalte1); p_lzeit->setText(_LZEIT); 
  p_text1=new QLineEdit(p_spalte1); p_text1->setValidator(intvalidator);

  // Feldparameter:
  QButtonGroup* p_vorrat=new QButtonGroup(3,Qt::Horizontal,"Chips:",p_spalte1);  // Anzeigetafel
  for (i=0; i<=12; i++) { my_button[i]=new QPushButton(p_vorrat); my_button[i]->setFixedSize(DX+4,DY+4); }

  // =================================================================       
  code="0123456789abcdef";
  aktlevel=-1;
  my_lliste=new QListBox();
  my_cliste=new QListBox();
  my_sliste=new QListBox();
  my_iliste=new QListBox();
  my_levels=new level(LEVELFILE); 
  updat_liste();
  aktlevel=my_cliste->count()+1;

  // Connections:
  connect(my_view,SIGNAL(geklickt(int,int)),this,SLOT(klick(int,int)));
  connect(my_view,SIGNAL(hover(int,int)),this,SLOT(hovern(int,int)));
  connect(p_vorrat,SIGNAL(clicked(int)),this,SLOT(waehle(int)));
}

// Slots: 
void window::level_laden(int nr)
{ int i;
  aktlevel=nr; 
  gewaehlt=0;
  p_cursor->setFrame(gewaehlt);
  QString temp; 
  temp=my_levels->my_level[aktlevel]->titel;   p_text->setText(temp);
  temp=temp.setNum(my_levels->my_level[aktlevel]->maxtime); p_text1->setText(temp);
  temp=my_levels->my_level[aktlevel]->levelcode;
  for (i=0; i<SMAX; i++) { f[i]=code.find(temp.at(i)); zeige_feld(i); }
  temp=temp.setNum(aktlevel);
  temp=_GELADEN+temp;
  p_messi->setText(temp);
}

void window::leeren()      { for (int i=0; i<SMAX; i++) { f[i]=0; zeige_feld(i); } }
void window::fill_oben()   { int i,c=f[0]; for (i=1; i<XMAX; i++) { f[i]=c; zeige_feld(i); } }
void window::fill_rechts() { int i,k=XMAX-1,c=f[k]; for (i=1; i<YMAX; i++) { k=k+XMAX; f[k]=c; zeige_feld(k); } }
void window::fill_unten()  { int i,k=SMAX-XMAX,c=f[k]; for (i=1; i<XMAX; i++) { f[i+k]=c; zeige_feld(i+k); } }
void window::fill_links()  { int i,c=f[0]; for (i=1; i<YMAX; i++) { f[i*XMAX]=c; zeige_feld(i*XMAX); } }

void window::nach_oben()
{ int i,j,k;
  for (i=0; i<XMAX; i++) 
  { for (j=0; j<YMAX-1; j++) { k=i+j*XMAX; f[k]=f[k+XMAX]; zeige_feld(k); }
    k=(YMAX-1)*XMAX+i; f[k]=0; zeige_feld(k);
  }
}

void window::nach_unten()
{ int i,j,k;
  for (i=0; i<XMAX; i++) 
  { for (j=YMAX-1; j>0; j--) { k=i+j*XMAX; f[k]=f[k-XMAX]; zeige_feld(k); }
    f[i]=0; zeige_feld(i);
  }
}

void window::nach_rechts()
{ int i,j,k;
  for (j=0; j<YMAX; j++) 
  { for (i=XMAX-1; i>0; i--) { k=i+j*XMAX; f[k]=f[k-1]; zeige_feld(k); }
    f[j*XMAX]=0; zeige_feld(j*XMAX);
  }
}

void window::nach_links()
{ int i,j,k;
  for (j=0; j<YMAX; j++) 
  { for (i=0; i<XMAX-1; i++) { k=i+j*XMAX; f[k]=f[k+1]; zeige_feld(k); }
    f[XMAX*(j+1)-1]=0; zeige_feld(XMAX*(j+1)-1);
  }
}

void window::zeige_feld(int nr)   { p_sprite[nr]->setFrame(f[nr]); }
void window::set_messi(QString p) { p_messi->setText(p); }
void window::set_feld(int nr)     { f[nr]=p_cursor->frame();; zeige_feld(nr); }

// Erguesse von QPushbutton: -------------------------------------------------------------------------------
void window::waehle(int nr) { p_cursor->setFrame(nr); }

void window::set_all_butts()
{ QImage ima; 
  for (int i=0; i<=12; i++) 
  { ima=pixarray->image(i)->convertToImage(); 
    my_button[i]->setPixmap(QPixmap(ima));
  }
}

// Erguesse von Viewport: ---------------------------------------------------------------------------------
void window::klick(int xx,int yy)  { int x=xx/DX,y=yy/DY,z=x+XMAX*y; set_feld(z); }
void window::hovern(int xx,int yy) { int mx=xx-DX/2,my=yy-DY/2; p_cursor->move(mx,my); }

// levelfile-Handling ========================================================================================
void window::updat_liste() // nach Speichern listen aktualisieren
{ int i,k;
  QString temp;
  my_levels=new level(LEVELFILE); 
  k=my_levels->anz_levels;
  my_lliste->clear();
  my_sliste->clear();
  my_cliste->clear();
  my_iliste->clear();
  for (i=0; i<k; i++) 
  { temp=temp.setNum(i); 
    temp=_LLEVEL+temp+": "+my_levels->my_level[i]->titel;
    my_lliste->insertItem(temp,-1); 
    my_sliste->insertItem(temp,-1); 
    my_cliste->insertItem(temp,-1); 
    my_iliste->insertItem(temp,-1); 
  }
  temp=temp.setNum(k);
  temp=_LLEVEL+temp+": "+_NLEVEL;
  my_iliste->insertItem(temp,-1);
}

QString window::mach_record()
{ bool ok=true;
  QString t0,t1,t2,t3,temp;
  if (p_text->text()=="")  { emit set_messi(_ERRLNAME); ok=false; }
  if (p_text1->text()=="") { emit set_messi(_ERRLZEIT); ok=false; }
  if (ok)
  { temp=p_text->text()+';'+p_text1->text()+';';
    for (int i=0; i<SMAX; i++) temp=temp+code.at(f[i]); 
  }
  else temp="";
  return temp;
}

bool window::backup()
{ bool ok=false;
  int i,j,k=my_levels->anz_levels,buffsize=2*SMAX;
  QString raus_damit,buff,temp=LEVELFILE; temp=temp+"_backup";
  set_messi(temp);
  QFile fb(temp);
  QFile fh(LEVELFILE);
  { if (fh.open(IO_ReadOnly))
    { raus_damit="";
      for (i=0; i<k; i++)
      { j=fh.readLine(buff,buffsize);
        raus_damit=raus_damit+buff;
      }
      fh.close();
      if (fb.open(IO_WriteOnly)) { j=fb.writeBlock(raus_damit,raus_damit.length()); fb.close(); ok=(j>0); }
    } 
  }
  return ok;
}

void window::level_anhaengen() 
{ int k=-1;
  bool ok=backup();
  QFile fh(LEVELFILE);
  QString rec=mach_record()+"\n";
  if (ok) if (rec!="\n")
  { ok=false;
    if  (fh.open(IO_WriteOnly|IO_Append)) 
    { k=fh.writeBlock(rec,rec.length()); 
      ok=(k>0);
      fh.close();
    } 
  }
  if (k>0) set_messi(_APPEND_OK);
  updat_liste();
}

void window::level_speichern(int nr) 
{ int i,j,k=my_levels->anz_levels,buffsize=2*SMAX;
  bool ok=backup();
  QFile fh(LEVELFILE);
  QString rec=mach_record()+"\n";
  QString raus_damit;
  QString buff;
  if (rec=="\n") ok=false;
  if (ok)
  { ok=false;
    if (fh.open(IO_ReadOnly))
    { raus_damit="";
      for (i=0; i<k; i++)
      { j=fh.readLine(buff,buffsize);
        if (i==nr) raus_damit=raus_damit+rec; else raus_damit=raus_damit+buff;
      }
      fh.close();
      if (fh.open(IO_WriteOnly)) { j=fh.writeBlock(raus_damit,raus_damit.length()); fh.close(); ok=(j>0); }
    } 
    updat_liste(); 
  }
  buff=buff.setNum(nr);
  buff=_SAVE_OK+buff;
  if (ok) set_messi(buff);
}

void window::level_einschieben_vor(int nr) 
{ int i,j,k=my_levels->anz_levels,buffsize=2*SMAX;
  bool ok=backup(); 
  QFile fh(LEVELFILE);
  QString rec=mach_record()+"\n";
  QString raus_damit;
  QString buff;
  if (rec=="\n") ok=false;
  if (ok)
  { ok=false;
    if (fh.open(IO_ReadOnly))
    { raus_damit="";
      for (i=0; i<k; i++)
      { if (i==nr) raus_damit=raus_damit+rec;
        j=fh.readLine(buff,buffsize);
	raus_damit=raus_damit+buff;
      }
      fh.close();
      if (nr>=k) raus_damit=raus_damit+rec;
      if (fh.open(IO_WriteOnly)) { j=fh.writeBlock(raus_damit,raus_damit.length()); fh.close(); ok=(j>0); }
    }      
    updat_liste(); 
  }
  buff=buff.setNum(nr);
  buff=_INSERT_OK+buff;
  if (ok) set_messi(buff);
}


void window::level_loeschen(int nr)  
{ int i,j=-1,k=my_levels->anz_levels,buffsize=2*SMAX;
  bool ok=backup();
  QFile fh(LEVELFILE);
  QString raus_damit;
  QString buff;
  if (ok) if (fh.open(IO_ReadOnly))
  { ok=false;
    raus_damit="";
    for (i=0; i<k; i++)
    { j=fh.readLine(buff,buffsize);
      if (i!=nr) raus_damit=raus_damit+buff;
    }
   fh.close();
   if (fh.open(IO_WriteOnly)) { j=fh.writeBlock(raus_damit,raus_damit.length()); fh.close(); ok=(j>0); }
    updat_liste(); 
  }
  buff=buff.setNum(nr);
  buff=_LOESCH_OK+buff; 
  if (ok) set_messi(buff);
}

// ==================================================================================================================
