/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Fleur which runs under GPL
*****************************************************************************************/

// Headerfile fuer Objekt window: window.h
// erstellt ein zweigeteiltes Fenster, links Grafikausgabe, rechts Eingabeparameter und Anzeigen
// Klamotten wie Help, Neu  Load und Save werden von QApplication in main.cpp erledigt
// ----------------------------------------------------------------------------------------------

#ifndef WINDOW_H
#define WINDOW_H
#include "llang.h"
#include "config.h"
#include "gamelib.h"
#include "levels.h"
#include <qvbox.h>        // Anzeige-Unterteilung
#include <qhbox.h>        // Basis dieses Windows
#include <qgrid.h>        // Unterteilungsgitter
#include <qlabel.h>       // Anzeigen 
#include <qcanvas.h>      // Spielwiese
#include <qradiobutton.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qbuttongroup.h>
#include <qlistbox.h>
#include <qfile.h>

class window:public QHBox
{
  Q_OBJECT

  private:
  int gewaehlt,aktlevel;
  int f[SMAX];
  QPushButton* my_button[13];
  QString code,nlname;

  QString mach_record();
  void zeige_feld(int);
  void set_feld(int);
  bool backup();
  
  private slots:
  void klick(int xx,int yy);
  void hovern(int xx,int yy);
  void waehle(int);
 
  public:
  window(QWidget* parent=0, char* name=0);
  void set_all_butts();

  viewport* my_view;
  level* my_levels;
  QListBox* my_lliste;
  QListBox* my_sliste;
  QListBox* my_cliste;
  QListBox* my_iliste;
  
  QLabel* p_messi;
  QLineEdit* p_text;
  QLineEdit* p_text1;
  QCanvasSprite* p_sprite[SMAX];
  QCanvasSprite* p_cursor;
  QCanvasPixmapArray* pixarray;
  QCanvasPixmapArray* helparray;
  
  
  public slots:
  void leeren();
  void fill_oben();
  void fill_unten();
  void fill_rechts();
  void fill_links();
  void nach_oben();
  void nach_unten();
  void nach_rechts();
  void nach_links();
  
  void level_laden(int);
  void level_speichern(int);
  void level_einschieben_vor(int);
  void level_anhaengen();
  void level_loeschen(int);
  void set_messi(QString);
  void updat_liste();
  
  signals:
  void loesche_levellisten();
  
};

#endif 
