/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Fleur II.
    
    Fleur/Fleur II is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later vezu Fuss an die QT-Libs III: schafe rsion.
	    
    bricks is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
	    
    You should have received a copy of the GNU General Public License
    along with Edelsteine; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************************/

// Hauptprogramm Fleur II
// Module erzeugen, Parameter lesen, Menu erstellen, Canvas und Sprites generieren, mit Appli verbinden
// --------------------------------------------------------------------------------------------------------

#include <qapplication.h>      // Fensterhandling-Event-Routinen
#include <qmenubar.h>          // Menuleiste
#include <qmenudata.h>         // Menu-Items
#include <qaccel.h>            // Shortcuts
#include <qradiobutton.h>      // Auswahl
#include <qbuttongroup.h>      // Auswahl
#include <qfile.h>             // INI-Dateien auswerten
#include <stdio.h>             // debugging
#include <qsound.h>
#include <qmessagebox.h>
#include "lang.h"     // laenderspezifische Texte
#include "config.h"   // Paraneter Darstellung, Spielgroesse, Dateien
#include "gamelib.h"  // ujas gamelib: viewport, hiscore, info-textmodule
#include "window.h"   // Hauptfenster Darstellung
#include "game.h"    // Gameparameter und -routinen 
#include "lala.h"    // Sound
// ===============================================================================

// -------------------------------------------------------------------------------------------------------

int main(int argc, char **argv)
{ 
  QApplication my_app(argc,argv);                  // die Fenster/Appli-Steuerung  
  window*      my_window    =new window();         // eine Instanz des zu zeigenden Spiel-Hauptfensters
  hiscore*     my_hiscore   =new hiscore();        // Bestenlisten-Hauptfenster
  textviewer*  my_textviewer=new textviewer();     // Fenster fuer Hilfstexte
  game*        my_game      =new game(my_window);  // spezifisch fuer Spiel: Wiese und Bewohner
  viewport*    my_view      =my_window->my_view;   // Darstellungsbereich des Spiels  
  lala*        my_lala      =new lala();
  int i,k;

// printf("Einlesen Ini-Files sound,levelset\n");
  QString buff="1;0";
  QString buff2;
  QFile fh(QString("./gameparm.ini"));
  if (fh.open(IO_ReadOnly)) { fh.readLine(buff,254); fh.close(); }
  buff2=buff.section(';',0,0); int soundon=buff2.toInt();
  buff2=buff.section(';',1,1); int chipset=buff2.toInt();

// Speichernamen Pattern 7 Schwestern;
  QString speicher[MAXSPEICHER];
  QFile fh1(QString("./speicher.ini"));
  if (fh1.open(IO_ReadOnly)) { fh1.readLine(buff,254); fh1.close(); } 
  for (i=0; i<MAXSPEICHER; i++) { speicher[i]=buff.section(';',i,i); }

// --- allgemeines Spielemenu: -----------------------------------------------------------------------------------------      
  QMenuBar*   my_menubar=new QMenuBar(my_window);  // Menubar mit Window verbinden    

// Menu game: neu, restart level, pause/weiter, Bestenliste/Reset, Quit  
  QPopupMenu* my_menu1=new QPopupMenu;
  my_menubar->insertItem(_GAME,my_menu1);
  my_menu1->insertItem(_NEU,      my_game,SLOT(neu()),       QKeySequence("CTRL+N"));   // _NEW kills Qt-library!
  my_menu1->insertItem(_RESTART,  my_game,SLOT(levelstart()),QKeySequence("CTRL+L"));
  my_menu1->insertItem(_PAUSECONT,my_game,SLOT(toggle_pause()),QKeySequence("CTRL+P"));
  my_menu1->insertSeparator();
  my_menu1->insertItem(_QUIT,&my_app,SLOT(quit()),QKeySequence("CTRL+Q"));  

// ----------------------------------------------------------------------

  QPopupMenu* my_menu2=new QPopupMenu;

  my_menubar->insertItem(_OPTIONS,my_menu2); 
  QButtonGroup* my_wig20=new QButtonGroup(1,Qt::Horizontal,_SOUND,0);
  QRadioButton* wig200=new QRadioButton(_OFF,my_wig20);
  QRadioButton* wig201=new QRadioButton("-10dB",my_wig20);
  QRadioButton* wig202=new QRadioButton("- 0dB",my_wig20);

  bool cpppatsch; cpppatsch=((wig200) && (wig201) && (wig202)); // irgendein Quatsch, damit der Compiler die Schnauze haelt
  my_wig20->setExclusive(true);
  my_wig20->setButton(soundon);
  my_menu2->insertItem(my_wig20,20); 
  my_app.connect(my_wig20,SIGNAL(clicked(int)),my_game,SLOT(set_sound(int)));
  my_menu2->insertSeparator();
  
  QButtonGroup* my_wig21=new QButtonGroup(1,Qt::Horizontal,"Chips:",0);
  QRadioButton* wig210=new QRadioButton("Glass",my_wig21);
  QRadioButton* wig211=new QRadioButton("Fleur",my_wig21);
  
  cpppatsch=((wig210) && (wig211)); // irgendein Quatsch, damit der Compiler die Schnauze haelt
  my_wig21->setExclusive(true);
  my_wig21->setButton(chipset);
  my_menu2->insertItem(my_wig21,21); 
  my_app.connect(my_wig21,SIGNAL(clicked(int)),my_game,SLOT(set_chipsatz(int)));
  
  my_menu2->insertSeparator();
  my_menu2->insertItem(_SAVEPARM,my_game,SLOT(save_settings()));

// ----------------------------------------------------------------------------------------------
// Menu Hiscore: show, reset, use local, use net, save settings 
  QPopupMenu* my_menu3=new QPopupMenu;
  my_menubar->insertItem(_HISCORE,my_menu3);
  my_menu3->insertItem(_SHOWHSC, my_hiscore,SLOT(show_hsc()),QKeySequence("CTRL+B"));
  my_menu3->insertItem(_HSCRESET,my_hiscore,SLOT(reset_hsc())); 

// ---------------------------------------------------------------------------------------------
// laden und speichern vom Spielstandspeicher:
  QPopupMenu* my_menu4=new QPopupMenu;
  my_menubar->insertItem(_LOAD,my_menu4);
  for (i=0; i<MAXSPEICHER; i++) 
  { k=i+40;
    my_menu4->insertItem(speicher[i],my_game,SLOT(load_game(int)),0,k);
    my_menubar->setItemParameter(k,i);
  }
  QPopupMenu* my_menu5=new QPopupMenu;
  my_menubar->insertItem(_SAVE,my_menu5);
  for (i=0; i<MAXSPEICHER; i++) 
  { k=i+50;
    my_menu5->insertItem(speicher[i],my_game,SLOT(save_game(int)),0,k);
    my_menubar->setItemParameter(k,i);
  }

//  Info-Menuitem:I
  QPopupMenu* my_menu6=new QPopupMenu;
  my_menubar->insertItem(_INFO,my_menu6);
  my_menu6->insertItem(_HELP,my_textviewer,SLOT(show_info(int)),QKeySequence("CTRL+H"),61);
  my_menu6->insertItem(_ABOUT,my_window,SLOT(about())); 
  my_menu6->insertItem("About Qt",&my_app,SLOT(aboutQt())); 
  my_menubar->setItemParameter(61,0);

// --------------------------------------------------------------------------------------------------------------------
// Canvas fuer Sprites e#define INIFILE   "./gameparm.ini"rzeugen, mit Viewport verbinden,
// Wiesen-Sprites belegen und mit Canvas verbinden:
  QCanvas* my_canvas=new QCanvas(DX*XMAX+2*OFX,DY*YMAX+2*OFY);
  my_view->setCanvas(my_canvas);
  my_canvas->setBackgroundColor(BACKGR1);
  my_canvas->setBackgroundPixmap(QPixmap(BACKPIX1));
  my_canvas->setDoubleBuffering(true);
  my_canvas->setAdvancePeriod(10);

  my_game->goverarray =new QCanvasPixmapArray(GAMEOVERFILE);
  my_game->pausearray =new QCanvasPixmapArray(PAUSEFILE);
  my_game->cursorarray=new QCanvasPixmapArray(CURSORFILE);
 
  my_game->bgrarray1   =new QCanvasPixmapArray(BGRSPRITE,3);
  my_game->chiparray1  =new QCanvasPixmapArray(CHIPSPRITE,NUMCHIPS+6);
  my_game->exploarray1 =new QCanvasPixmapArray(EXPLOSPRITE,16);
  my_game->bgrarray2   =new QCanvasPixmapArray(BGRSPRITE1,3);
  my_game->chiparray2  =new QCanvasPixmapArray(CHIPSPRITE1,NUMCHIPS+6);
  my_game->exploarray2 =new QCanvasPixmapArray(EXPLOSPRITE1,16);

  my_game->bgrarray   =my_game->bgrarray1;
  my_game->chiparray  =my_game->chiparray1;
  my_game->exploarray =my_game->exploarray1;


  // Check auf Vollstaendigkeit der Bilder:
  QString err="";
  if (!my_game->goverarray->isValid())  err=err+"Gameover Pic is missing!\n";
  if (!my_game->pausearray->isValid())  err=err+"Pause Pic is missing!\n";
  if (!my_game->cursorarray->isValid()) err=err+"The Pointer is missing!\n";
  if (!my_game->bgrarray->isValid())    err=err+"Some field pix are missing!\n";
  if (!my_game->chiparray->isValid())   err=err+"Some Chip Pics are missing!\n";
  if (!my_game->exploarray->isValid())  err=err+"Some Fireworks are missing!\n";

  if (err=="")  // Spritebelegung und Initialisierung:
  { my_game->p_gover=new QCanvasSprite(my_game->goverarray,my_canvas);
    my_game->p_pause=new QCanvasSprite(my_game->pausearray,my_canvas);
    my_game->p_cursor=new QCanvasSprite(my_game->cursorarray,my_canvas);
    my_game->p_pause->move(3*DX,5*DY); my_game->p_pause->setZ(97); my_game->p_pause->setVelocity(0,0);
    my_game->p_gover->move(3*DX,5*DY); my_game->p_gover->setZ(98); my_game->p_gover->setVelocity(0,0);
    my_game->p_cursor->move(3*DX,5*DY); my_game->p_cursor->setZ(99); my_game->p_cursor->setVelocity(0,0);
    my_game->p_cursor->show();

    int x=0,y=0;
    for (i=0; i<SMAX; i++) 
    { x=i%XMAX; y=(i-x)/XMAX;
      x=x*DX+OFX; y=y*DY+OFY;
      my_game->p_bgr[i]=new QCanvasSprite(my_game->bgrarray,my_canvas);
      my_game->p_bgr[i]->setZ(1); 
      my_game->p_bgr[i]->move(x,y,i%2);
      my_game->p_bgr[i]->setVelocity(0,0);
      my_game->p_bgr[i]->show();

      my_game->p_chip[i]=new QCanvasSprite(my_game->chiparray,my_canvas);
      my_game->p_chip[i]->setVelocity(0,0);
      my_game->p_chip[i]->setZ(2); 
      my_game->p_chip[i]->move(x,y,i%10);
      my_game->p_chip[i]->show();

      my_game->block[i]->p_sprite=new QCanvasSprite(my_game->exploarray,my_canvas);
      my_game->block[i]->p_sprite->setVelocity(0,0);
      my_game->block[i]->p_sprite->setZ(3); 
      my_game->block[i]->p_sprite->move(x,y);
      my_game->block[i]->p_sprite->hide();

    }

    my_view->setContentsPos(0,0);
    my_view->polish();
    my_view->show();
  }	    
  else printf(err); // Bilder fehlen

// ---------------------------------------------------------------------------------------------------------------------
  my_app.setMainWidget(my_window);


  my_app.connect(my_view,SIGNAL(geklickt(int,int)),my_game,SLOT(geklickt(int,int)));   // Klick ins Spielfeld,  Parameter: Quadrant 
  my_app.connect(my_view,SIGNAL(hover(int,int)),my_game,SLOT(hover(int,int)));      // Zielfernrohr 
  my_app.connect(my_game,SIGNAL(gameover(int)),my_hiscore,SLOT(save_hsc(int)));     // Auswertung Spielende. Parameter: Punkte

  my_app.connect(my_game,SIGNAL(punkte_changed(int)),my_window,SLOT(set_punkte(int)));   // Punktestandsanzeige
  my_app.connect(my_game,SIGNAL(messi(QString)),my_window,SLOT(set_messi(QString)));
  my_app.connect(my_game,SIGNAL(level_changed(QString)),my_window,SLOT(set_level(QString)));
  my_app.connect(my_game,SIGNAL(play_lala(int,int)),my_lala,SLOT(mach_lala(int,int)));
  my_app.connect(my_game,SIGNAL(zeit_changed(int)),my_window,SLOT(set_zeit(int)));
  my_app.connect(my_game,SIGNAL(rest_changed(int)),my_window,SLOT(set_rest(int)));

  my_app.connect(my_window->p_neu,SIGNAL(clicked()),my_game,SLOT(neu()));
  my_app.connect(my_window->p_pause,SIGNAL(clicked()),my_game,SLOT(toggle_pause()));
  my_app.connect(my_window->p_aufgeben,SIGNAL(clicked()),my_game,SLOT(game_over()));
  my_app.connect(my_window->p_restart,SIGNAL(clicked()),my_game,SLOT(levelstart()));
  my_app.connect(my_game,SIGNAL(is_pause(bool)),my_window,SLOT(pause(bool)));

  my_game->set_sound(soundon);
  my_game->set_chipsatz(chipset);
  my_game->neu();
  QPixmap my_pixmap=QPixmap(PROGICON); 
  my_window->setIcon(my_pixmap);
  my_window->show();

//  printf("Breite x Hoehe %i x %i\n",my_window->width(),my_window->height());    // Debug-Info
  return my_app.exec();
}
