#!/bin/sh
##########################################################
# Installer ujagames_qt: fleur2 deutsch aRts-Soundserver #
##########################################################

# Bibliotheken finden: 
########################
KDEPFAD=""
KDEPFAD="$(kde-config --prefix)"

KDELIBS="$(find $KDEPFAD|grep libartsc.so$)"
KDELIBS="$(echo $KDELIBS|sed 's/libartsc.so//')"

ARTSINCLUDE="$(find $KDEPFAD|grep soundserver.h$)"
ARTSINCLUDE="$(echo $ARTSINCLUDE|sed 's/soundserver.h//')"

# hier eigenen Pfad eintragen:
# KDELIBS=/kderoot kdeversion/lib
# ARTSINCLUDE=/kderoot kdeversion/include/arts

if [ ! -d $KDELIBS ]
then
echo "aRts-Bibliothekspfad $KDELIBS nicht gefunden! Bitte haendisch eintragen in $0!"
exit 1
fi

if [ ! -d $ARTSINCLUDE ]
then
echo "aRts-Headerpfad $ARTSINCLUDE nicht gefunden! Bitte haendisch eintragen in $0!"
exit 1
fi

echo
echo "Soundbibliotheken gefunden in $KDELIBS und $ARTSINCLUDE"


###################################################################################################################

# Programkopf: 
################
echo "----------------------------------------------"
echo "Installation Fleur2 KDE/aRts deutsch"
echo "----------------------------------------------"

######################################################
# Subroutinen:
# compiling, linking:
mach_hin()
{
echo "Compilieren, Linken"
echo "--------------------------------------"
make
ret=$?
if [ $ret -ne 0 ] 
then
 echo "Fehler: konnre das Programm nicht compilieren/linken"
 exit 2
fi

echo " Installation erfolgreich "
echo ----------------------------------------
}


# Ende Subroutinen
##########################################################

$path
cd fleur2
workdir=$PWD

echo " Step 1: Erzeugen des .pro-files:"
echo "---------------------------------"

cat >fleur2.pro<<ENDCAT
# fleur2.pro - generiert von bash
##################################
TEMPLATE = app
TARGET = fleur2

INCLUDEPATH += . ./deutsch ./arts $ARTSINCLUDE
LIBS        += -lsoundserver_idl -L$KDELIBS

CONFIG += qt

# Input
HEADERS +=  deutsch/lang.h config.h gamelib.h window.h levels.h game.h arts/lala.h arts/arts.h
SOURCES +=  main.cpp gamelib.cpp window.cpp levels.cpp game.cpp arts/lala.cpp arts/arts.cpp
ENDCAT

echo "fleur2.pro wurde erstellt"
echo "-------------------------"
echo


echo
echo "Step 2: Erzeugen des Makefile "
echo "---------------------------------------------------"

qmake fleur2.pro
ret=$?
if [ $ret -ne 0 ]
then
 echo "Fehler: Konnte Makefile nicht generieren! (QTDIR und aRts-Libs vorhanden?)"
 exit 1
fi
mach_hin

echo "Installation Leveleditor "
qmake editor_deu.pro
ret=$?
if [ $ret -ne 0 ]
then
 echo "Fehler: Konnte Makefile nicht generieren! (QTDIR vorhanden?)"
 exit 1
fi
mach_hin

echo "lsche temporre Dateien"
echo "--------------------------------------"
for i in $( ls *.o  )
do 
  rm $i
done
for i in $( ls moc*  )
do 
  rm $i
done
rm Makefile
rm arts/moc_lala.cpp
rm arts/moc_arts.cpp


echo "Installation abgeschlossen"
echo "Um das Programm zu starten, zum Directory fleur2 wechseln, ./fleur2 aufrufen"
echo "============================================================================"
exit 0

####################################################################################


